classification
Title: Move CallTips tests to idle_tests
Type: enhancement Stage: resolved
Components: IDLE, Tests Versions: Python 3.3, Python 3.4, Python 2.7
process
Status: closed Resolution: fixed
Dependencies: Superseder:
Assigned To: terry.reedy Nosy List: kbk, python-dev, roger.serwy, serhiy.storchaka, terry.reedy
Priority: normal Keywords: patch

Created on 2014-01-04 16:24 by serhiy.storchaka, last changed 2014-01-21 05:32 by terry.reedy. This issue is now closed.

Files
File name Uploaded Description Edit
test_calltips.patch serhiy.storchaka, 2014-01-04 16:24 review
test_calltips-33.diff terry.reedy, 2014-01-19 03:06 review
test_calltips-27.diff terry.reedy, 2014-01-19 06:21 review
Messages (6)
msg207291 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2014-01-04 16:24
Proposed patch moves CallTips tests from Lib/idlelib/CallTips.py to Lib/idlelib/idle_test/test_calltips.py and converts them to unittests.

Private keyword-only parameter _namespace was added to fetch_tip() and get_entity().
msg207363 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-01-05 07:53
It is a good idea to make this a separate patch;-). Will look carefully after sleep.
msg207816 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-01-10 01:45
The existing tests in CallTips.py, half of which I wrote based on the ones that existed, have one or two deficiencies that are copied in the patch.

First, they are not proper unittests. They test get_argspec indirectly by calling .fetch_tip and get_entity. This lead to the new private parameter, which will not be needed for the existing tests when get_argspec is called directly with objects.

Adding more tests for get_entity, beyond the one in test_calltips.py already, is a different issue. The function is mostly a wrapper for eval(), which we may assume works correctly.

Second, the doubling resulting from putting expected output in docstrings seems a bit flakey. It certainly does not test cases with no docstring or multiple-line docstrings.

I am working on a revised patch. (Also, the unittest call was added with test_calltip.py and I want it left.)

In 2.7. get_argspec is get_arg_text, with a different implementation. Backporting to 2.7 will require some adjustments.
msg208433 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-01-19 03:06
Attached patch moves all tests, changed (and simplified) to call get_argspec directly. I will apply after I get tk 8.6 to test with 3.4.
msg208454 - (view) Author: Terry J. Reedy (terry.reedy) * (Python committer) Date: 2014-01-19 06:21
Attached is patch for 2.7 with all tests passing. 3.x get_argspec cannot replace 2.x get_arg_text because it uses inspect.getfullargspec, which does not exist in 2.7. (Its use made the code simpler.) Besides minor changes in test_calltips.py, I made 3 changes to get_arg_text() to get tests to pass.
1. Stop deleting first parameter for unbound methods (bugfix).
2. Replace class instances with __call__ methods (bugfix).
3. Change tip for def f(*some_name, **other_name) from '(..., ***)' to '(*args, **kwds)'. 2.7 either does not keep the dummy names, which anyway cannot be used when calling , or the current code makes no effort to retrieve them.

My reasons for 3. are that the replacement is a) the current convention everywhere else, b) more like the corresponding 3.x tip (which has the exact names), and c) more indicative of what one actually writes in a call.
msg208615 - (view) Author: Roundup Robot (python-dev) Date: 2014-01-21 05:31
New changeset f6f2d9d04cd0 by Terry Jan Reedy in branch '2.7':
Issue #20122: Idlelib: Move tests in 3.x CallTips.py to test_calltips.py.
http://hg.python.org/cpython/rev/f6f2d9d04cd0

New changeset 7befcc353d40 by Terry Jan Reedy in branch '3.3':
Issue #20122: Idlelib: Move tests in CallTips.py to test_calltips.py.
http://hg.python.org/cpython/rev/7befcc353d40
History
Date User Action Args
2014-01-21 05:32:33terry.reedysetstatus: open -> closed
resolution: fixed
stage: patch review -> resolved
2014-01-21 05:31:30python-devsetnosy: + python-dev
messages: + msg208615
2014-01-19 06:21:50terry.reedysetfiles: + test_calltips-27.diff

messages: + msg208454
2014-01-19 03:06:59terry.reedysetfiles: + test_calltips-33.diff

messages: + msg208433
2014-01-10 01:45:10terry.reedysetmessages: + msg207816
2014-01-05 07:53:51terry.reedysetassignee: terry.reedy
messages: + msg207363
2014-01-04 16:48:09serhiy.storchakalinkissue16638 dependencies
2014-01-04 16:29:51serhiy.storchakalinkissue7883 dependencies
2014-01-04 16:28:54serhiy.storchakalinkissue16655 dependencies
2014-01-04 16:28:05serhiy.storchakalinkissue19903 dependencies
2014-01-04 16:26:15serhiy.storchakalinkissue16630 dependencies
2014-01-04 16:24:58serhiy.storchakacreate